<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
require_once REPORT_COMMON_BLOCK;
require_once '/usr/local/esia/public_html/plugin/egidescan/model_egidescan.php';


if($action=="generate")
{
    //code qui va générer l'HTML du bloc (attention en CRON au DOCUMENT_ROOT qui n'existe pas
	//function : getReportIncludeBlock / 

	$parameters = $block['parameters'];
	$userid=null;
	if(is_null($user)==false)
	{
		$userid = $user->getId();
	}
	else
	{
		$report_user = Model_Report::getOwnerCanevas($dbconnection,$block['include_canevas_id']);
		$userid = $report_user[0];
	}
	//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	$devices_table = Model_egidescan::getDevices($dbconnection);
	$device_id =array();
	$index_device_id = 0 ;
	for($i=0; $i<count($devices_table);$i++)
	{
		if(!in_array($devices_table[$i]['eg_device_id'], $device_id))
		{
			$device_id[$index_device_id] = $devices_table[$i]['eg_device_id'] ;
			$index_device_id ++ ;
		}
	}
	
	$services_device = array() ; $services_device_index = 0 ;
	$severity_of_node = array();
	$faille_numbres = array();
	$max_faille = array();
	
	foreach ($device_id as $id)
	{
		$max_faille[$id] = 0 ;
	}
	
	for($j=0; $j<count($device_id);$j++)
	{
		$services_device = array() ; $services_device_index = 0 ;
		for($i=0; $i<count($devices_table);$i++)
		{
			if($devices_table[$i]['eg_device_id']==$device_id[$j])
			{
				$services_device[$services_device_index] = $devices_table[$i]['eg_service_id'] ;
				$services_device_index ++ ;
			}
		}
		
		for($k=0; $k<count($services_device);$k++)
		{
			// recupererer les id cve
			$val1 = Model_egidescan::getDetectCVEid($dbconnection,$services_device[$k]);
			// reecup les cve
			foreach ($val1 as $value)
			{
				$faille_numbres[$device_id[$j]]++ ;
				$val2 = Model_egidescan::getCVE($dbconnection,$value['detect_vul_id1']);
				$val3 = $val2['cve_score'] ;
				$max_faille[$device_id[$j]] = max($max_faille[$device_id[$j]],$val2['cve_score']) ;
				$severity_of_node[$device_id[$j]] = $severity_of_node[$device_id[$j]] + $val3 ;
			}
		}
	}
	
	arsort($severity_of_node) ;
	
	$node_severity_keys = array_keys($severity_of_node);
	$sortedArray = array();
	// $node_severity = array();
	$topX = $parameters['nbr_node'] ;
	$sortedArray_index = 0 ;
	foreach($severity_of_node as $key=>$i)
	{
		// 	$key = array_search($i, $severity_of_node) ;
		$device_name_and_type = Model_egidescan::getDeviceEsia($dbconnection,$key);
		$device_name = $device_name_and_type['dv_name'] ;
		$device_type = $device_name_and_type['dv_type'] ;
		$sortedArray[$sortedArray_index]=array(
			'device' => $device_name,
			'type' => $device_type,
			'scoring' => round($i*10/$faille_numbres[$key],2),
			'vul_number' => $faille_numbres[$key],
			'score_max' => $max_faille[$key]
		);
		if($parameters['affiche_NODE']!='on')
		{
			unset($sortedArray[$sortedArray_index]["device"]);
		}
		if($parameters['affiche_TYPE']!='on')
		{
			unset($sortedArray[$sortedArray_index]["type"]);
		}
		if($parameters['affiche_SCORING']!='on')
		{
			unset($sortedArray[$sortedArray_index]["scoring"]);
		}
		if($parameters['affiche_MAX_SCORING']!='on')
		{
			unset($sortedArray[$sortedArray_index]["score_max"]);
		}
		if($parameters['affiche_NBR_CVE']!='on')
		{
			unset($sortedArray[$sortedArray_index]["vul_number"]);
		}
		if ($sortedArray_index == $topX-1) 
		{
			break;
		}
		$sortedArray_index ++ ;
	}
	$smarty->assign('sortedArray',$sortedArray);
	//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
}
elseif($action=="update")
{
    //Code permettant l'administration du bloc
	$nodes = Model_esia::getNodeList($dbconnection, $user->getId(), NULL, Model_esia::NODE_ASSOC);
	$nodesList = array();
	foreach($nodes as $node)
	{
		$nodesList[] = array('id' => $node['id'], 'name' => $node['name']);
	}
	$smarty->assign('adm_list_node', $nodesList);
	
	
        $parameters = $block['parameters'];
	$smarty->assign('param',$parameters);	
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
                //on traite le formulaire
		try
		{ 
                       //traite les données post pour le style du titre et de la description
						$block = getPostDefaultParams($block,$_POST);
						$parameters = $block['parameters'];
						$parameters['affiche_NODE']=$_POST['NODE'];
						$parameters['affiche_TYPE']=$_POST['TYPE'];
						$parameters['affiche_SCORING']=$_POST['SCORING'];
						$parameters['affiche_MAX_SCORING']=$_POST['SCORING'];
						$parameters['affiche_NBR_CVE']=$_POST['NBR_CVE'];
						$parameters['nbr_node']=$_POST['nbr_node'];                      
                       //traitement des variable POST
			$paramSave = json_encode($parameters);
			Model_Report::UpdtReportIncludeBlock($dbconnection,$block['id'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);
                        //la variable l_success est affichée en rouge dans le smarty
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
                        //la variable l_error est affichée en rouge dans le smarty
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}   
       }
       //récupération des styles:
       	//recupération des styles
	$title = $parameters['title']['style'];
	$description = $parameters['description']['style'];
	$title = getBlockStyle($title,14,'left','#575759');
	$description = getBlockStyle($description,12,'left','#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
        //récupération des données pour l'affichage
        //on fixe le mode update
        $smarty->assign('action','update');
}


//chemin d'accès au template de votre block
$smarty->display($webplugin_path.'blocks/templates/egidescan_node.html');
?>
