<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
require_once REPORT_COMMON_BLOCK;
require_once '/usr/local/esia/public_html/plugin/inventory/Model_inventory.php';
 
if($action=="generate")
{
    //code qui va générer l'HTML du bloc (attention en CRON au DOCUMENT_ROOT qui n'existe pas
    
    $parameters = $block['parameters'];
    
    $type_graphic = $parameters['graphic'];
    $display ="";
    if($parameters['hardware']=='on')
    {
        $display .='HARDWARE,';
    }
    if($parameters['software']=='on')
    {
        $display .='SOFTWARE,';
    }
    $display = rtrim($display,',');
    if($parameters['graphic'] == "DONUT" || $parameters['graphic'] == "BAR" || $parameters['graphic'] == "PIE")
    {
        
        if($parameters['type']=="noeud" || $parameters['type']=="group_node")
        {
            $tab_id_node = array();
            //on créer un tableau de noeud
            if($parameters['type']=="noeud")
            {
                $tab_id = $parameters['nodeid'];
                $list_id = "";
                foreach($tab_id as $node)
                {
                    $list_id .= $node.",";
                }
                $list_id = rtrim($list_id,',');
                
                $manufacturers = Model_inventory::getReportCountManufacturer($dbconnection,$tab_id,$display);
            }
            
            else // Type groupe de noeud
            {
                $tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$parameters['groupnodeid']);
                foreach ($tab_group_node as $node)
                {
                    $tab_id_node[] = $node->getId();
                }
                $manufacturers = Model_inventory::getReportCountManufacturer($dbconnection,$tab_id_node,$display);
            }
        }
        else
        {
            
            $manufacturers = Model_inventory::getReportCountManufacturer($dbconnection,NULL,$display);
            
               
                
               
           
        }
        
       
    }
    else
    {
        // TODO : Traitement graphic tableau
    }
    
    $smarty->assign('inclusion',$block['include_id']);
    $smarty->assign('type_graphic',$type_graphic);
    $smarty->assign('manufacturers',$manufacturers);
}
elseif($action=="update")
{
    //Code permettant l'administration du bloc
    $parameters = $block['parameters'];
	$smarty->assign('param',$parameters);	
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
                //on traite le formulaire
		try
		{ 
            //traite les données post pour le style du titre et de la description
            $block = getPostDefaultParams($block,$_POST);
           
            $parameters = $block['parameters'];
            //traitement des variable POST
            
            if ($parameters['type']=='noeud')
			{
				$parameters['nodeid']=$_POST['nodes'];
			}
            elseif($parameters['type']=='group_node')
            {
                $parameters['groupnodeid']=$_POST['groupnodes'];
            }
            else
            {
                $parameters['type']='global';
            }
            $parameters['component_description']=$_POST['component_description'];
            $parameters['graphic']=$_POST['graphic'];
            $parameters['hardware'] =$_POST['hardware'];
            $parameters['software'] =$_POST['software'];
            
			$paramSave = json_encode($parameters);
			Model_Report::UpdtReportIncludeBlock($dbconnection,$block['id'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);
            //la variable l_success est affichée en rouge dans le smarty
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
            //la variable l_error est affichée en rouge dans le smarty
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}   
    }
    //récupération des styles:
    //recupération des styles
	$title = $parameters['title']['style'];
	$description = $parameters['description']['style'];
	$title = getBlockStyle($title,14,'left','#575759');
	$description = getBlockStyle($description,12,'left','#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
        //récupération des données pour l'affichage
        
    if($parameters['type']=="noeud")
	{
		//Récupération des noeuds
		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		$list=array();
		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$parameters['nodeid']))
			{
				$selected='yes';
			}
			$list[]=array('id'=>$node->getId(),
					'name'=>$node->getGroup().'>'.$node->getName(),
					'selected'=>$selected

			);
		}
	}
    if($parameters['type'] =="group_node")
    {
        $groupNode = Model_esia::getGroupDeviceIn($dbconnection);
        $list_group_node =array();
        //echo var_dump($groupNode);
        foreach($groupNode as $group)
        {
            $select='no';
            if(in_array($group['id'],$parameters['groupnodeid']))
            {
                $select='yes';
            }
            $list_group_node[]=array('id'=>$group['id'],
                          'name'=>$group['name'],
                          'selected'=>$select
                          );
        }
        
    }
    
    
    
    $smarty->assign('adm_list_node', $list);
	$smarty->assign('adm_list_group_node', $list_group_node);
	
    //on fixe le mode update
    $smarty->assign('action','update');
}
//chemin d'accès au template de votre block
$smarty->display($webplugin_path.'blocks/templates/inventory_manufacturer.html');
?>

