<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
require_once REPORT_COMMON_BLOCK;
require_once '/usr/local/esia/public_html/plugin/egidescan/model_egidescan.php';


if($action=="generate")
{
    //code qui va générer l'HTML du bloc (attention en CRON au DOCUMENT_ROOT qui n'existe pas
	//function : getReportIncludeBlock /

	$parameters = $block['parameters'];
	$userid=null;
	if(is_null($user)==false)
	{
		$userid = $user->getId();
	}
	else
	{
		$report_user = Model_Report::getOwnerCanevas($dbconnection,$block['include_canevas_id']);
		$userid = $report_user[0];
	}
	//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	if($parameters['type']=="groupenoeud")
	{
		$tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$parameters['groupnodeid']);
		foreach ($tab_group_node as $node)
		{
			$nodes[] = $node->getId();
		}
	}
	else
	{
		$nodes = $parameters['nodeid'] ;
	}


	$devices = Model_egidescan::getDevices($dbconnection) ;

	$cleaner_device = array();
	foreach ($devices as $value)
	{
		if(in_array($value['eg_device_id'], $nodes))
		{
			$cleaner_device[] = $value['eg_service_id'] ;
		}
	}

	$row = Model_egidescan::getEgideVulDetect($dbconnection);

	$all_cve = array(); $j = 0;
	for($i=0; $i<count($row);$i++)
	{
		$all_cve[$j]=array(
			"detect_eg_service_id" => $row[$i]['detect_eg_service_id1'],
			"detect_vul_id1" => $row[$i]['detect_vul_id1']
		);
		$j++;

		if(!in_array($row[$i]['detect_eg_service_id1'], $cleaner_device))
		{
			unset($all_cve[$i]);
			$j-- ;
		}
	}

	$cve_table = array();
	$index_cve_table = 0 ;
	$match_faille = array() ;
	for($i=0; $i<count($all_cve);$i++)
	{
		if(!in_array($all_cve[$i]['detect_vul_id1'], $cve_table))
		{
			$cve_table[$index_cve_table]=$all_cve[$i]['detect_vul_id1'] ;
			$match_faille[$all_cve[$i]['detect_vul_id1']] = 1 ;
			$index_cve_table ++ ;
		}
		else
		{
			$match_faille[$all_cve[$i]['detect_vul_id1']] ++ ;
		}
	}

	$severity_table = array() ; $all_scores = array();
	// nettoyage de code { $cve_unique = array(); }

	$lang_fr_CVE_severity = $lang['EGIDE_CVE_SEVERITY_TYPE'];

	for($i=0; $i<count($cve_table);$i++)
	{
		$arr = Model_egidescan::getCVE($dbconnection,$cve_table[$i]);

		// nettoyage de code { $cve_unique[] = $arr['cve'] ; };
		$all_scores[] = $arr['cve_score'] ;
		$severity_table[$i]=array(
			"vulnerability_id" =>$arr['cve'],
			"match_noeud" => $match_faille[$cve_table[$i]],
			"vulnerability_description" =>$arr['cve_descr'],
			"vulnerability_scoring" => $arr['cve_score'],
			'cve_severt' => $arr['cve_severt'],
			'cve_cmplx' => $arr['cve_cmplx'],
		);
		if($parameters['affiche_CVE']!='on')
		{
			unset($severity_table[$i]["vulnerability_id"]);
		}
		if($parameters['affiche_MATCHES']!='on')
		{
			unset($severity_table[$i]["match_noeud"]);
		}
		if($parameters['affiche_DESCRIPTION']!='on')
		{
			unset($severity_table[$i]["vulnerability_description"]);
		}
		if($parameters['affiche_SCORING']!='on')
		{
			unset($severity_table[$i]["vulnerability_scoring"]);
		}
		if($parameters['affiche_SEVERITY']!='on')
		{
			unset($severity_table[$i]["cve_severt"]);
		}
		if($parameters['affiche_COMPLEXITY']!='on')
		{
			unset($severity_table[$i]["cve_cmplx"]);
		}
	}
	$vulnerability_array = $severity_table ;
	$smarty->assign('vulnerability_array',$vulnerability_array);

	$vulnerability_array_topX = array();
	$vulnerability_array_match = array();
	$vulnerability_array_match_indice = array();
	$vulnerability_array_match_i = 0;

	foreach ($vulnerability_array as $value)
	{
		$vulnerability_array_match[] = $value['match_noeud'] ;
		$vulnerability_array_match_indice[] = $vulnerability_array_match_i ;
		$vulnerability_array_match_i ++ ;
	}

	arsort($vulnerability_array_match);
	$topX = $parameters['nbr_cve'] ;
	$limite_10 = 0;
	foreach ($vulnerability_array_match as $key => $value)
	{
		if($limite_10<$topX)
		{
			$vulnerability_array_topX[] = $vulnerability_array[$key] ;
			$limite_10 ++;
		}
	}

	$smarty->assign('vulnerability_array_top10',$vulnerability_array_topX);
	//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
}
elseif($action=="update")
{
    //Code permettant l'administration du bloc
	$parameters = $block['parameters'];
	if($parameters['type']=="noeud")
    {
		$nodes = Model_esia::getNodeList($dbconnection, $user->getId(), NULL, Model_esia::NODE_ASSOC);
		$nodesList = array();
		foreach($nodes as $node)
		{
			$nodesList[] = array('id' => $node['id'], 'name' => $node['name']);
		}
		$smarty->assign('adm_list_node', $nodesList);
    }
	else
	{
		$list = Model_esia::getNodeGroupHierarchyByUser($dbconnection,$user->getId());
		$list_group_node=array();
		foreach($list as $node)
		{
			$selected='no';
			if(in_array($node['id'],$parameters['groupnodeid']))
			{
				$selected='yes';
			}

			$list_group_node[]=array('id'=>$node['id'],
				'name'=>$node['name'],
				'selected'=>$selected);
		}
		$smarty->assign('adm_list_group_node', $list_group_node);
	}


	$smarty->assign('param',$parameters);
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
                //on traite le formulaire
		try
		{
                       //traite les données post pour le style du titre et de la description
						$block = getPostDefaultParams($block,$_POST);
						$parameters = $block['parameters'];
						$parameters['affiche_CVE']=$_POST['CVE'];
						$parameters['affiche_MATCHES']=$_POST['MATCHES'];
						$parameters['affiche_DESCRIPTION']=$_POST['DESCRIPTION'];
						$parameters['affiche_SCORING']=$_POST['SCORING'];
						$parameters['affiche_SEVERITY']=$_POST['SEVERITY'];
						$parameters['affiche_COMPLEXITY']=$_POST['COMPLEXITY'];
						$parameters['nbr_cve']=$_POST['nbr_cve'];
						if($parameters['type']=='noeud')
						{
							$parameters['nodeid']=$_POST['nodes'];
						}
						else
						{
							$parameters['groupnodeid']=$_POST['groupnodes'];
						}

                       //traitement des variable POST
			$paramSave = json_encode($parameters);
			Model_Report::UpdtReportIncludeBlock($dbconnection,$block['id'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);
                        //la variable l_success est affichée en rouge dans le smarty
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
                        //la variable l_error est affichée en rouge dans le smarty
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
       }

	   assignCommonStyles($smarty,$parameters);

        //récupération des données pour l'affichage
        //on fixe le mode update
        $smarty->assign('action','update');
}


//chemin d'accès au template de votre block
$smarty->display($webplugin_path.'blocks/templates/egidescan.html');
?>
