<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
require_once REPORT_COMMON_BLOCK;
require_once '/usr/local/esia/public_html/plugin/egidescan/model_egidescan.php';
require_once '/usr/local/esia/public_html/plugin/egidescan/common_egidescan.php';


if($action=="generate")
{
    //code qui va générer l'HTML du bloc (attention en CRON au DOCUMENT_ROOT qui n'existe pas
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	$parameters = $block['parameters'];

	$devices_table = Model_egidescan::getDevices($dbconnection);
	$device_id =array();
	$index_device_id = 0 ;
	for($i=0; $i<count($devices_table);$i++)
	{
		if(!in_array($devices_table[$i]['eg_device_id'], $device_id))
		{
			$device_id[$index_device_id] = $devices_table[$i]['eg_device_id'] ;
			$index_device_id ++ ;
		}
	}
	$services_device = array() ; $services_device_index = 0 ;
	$services_devices = array();
	for($j=0; $j<count($device_id);$j++)
	{
		$services_device = array() ; $services_device_index = 0 ;
		for($i=0; $i<count($devices_table);$i++)
		{
			if($devices_table[$i]['eg_device_id']==$device_id[$j])
			{
				$services_device[$services_device_index] = $devices_table[$i]['eg_service_id'] ;
				$services_device_index ++ ;
			}
		}
		
		for($k=0; $k<count($services_device);$k++)
		{
			// recupererer les id cve
			$services_devices[$device_id[$j]] = $services_device ;
		}
	}
	
	$vulnerability_nodes = array() ;$h= 0 ; $matches = array();
	
	if($parameters['type']=="groupenoeud")
	{
		$tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$parameters['groupnodeid']);
		foreach ($tab_group_node as $node)
		{
			$nodes[] = $node->getId();
		}
	}
	else
	{
		$nodes = $parameters['nodeid'] ;
	}
	
	
	foreach ($nodes as $devices_idxx)
	{
		foreach ($services_devices[$devices_idxx] as $value2)
		{
			$val1 = Model_egidescan::getDetectCVEid($dbconnection,$value2);
			foreach ($val1 as $value)
			{
				$val2 = Model_egidescan::getCVE($dbconnection,$value['detect_vul_id1']);
				$vulnerability_nodes[$val2['cve']] = $val2 ;
				if(isset($matches[$val2['cve']]))
				{
					$matches[$val2['cve']]++ ;
					$vulnerability_nodes[$val2['cve']]['match']=$matches[$val2['cve']] ;
				}
				else
				{
					$matches[$val2['cve']] =1 ;
					$vulnerability_nodes[$val2['cve']]['match']=$matches[$val2['cve']] ;
				}
				// 		$services_devices[$device_id[$j]] = $services_device ;
			}
		}
	}
	
	$lang_fr_CVE_severity = $lang['EGIDE_CVE_SEVERITY_TYPE'];

	$all_scores = assignDonutAndVulnerabilities($smarty,$vulnerability_nodes,$lang_fr_CVE_severity,TRUE) ;
	
	$severity_class = array();
	for($i=0;$i<10;$i++)
	{
		$j = $i+1 ;
		$severity_class[$i]="$i - $j";
	}
	
	$classed_severity = array(); $paramColor = array();
	for($i=0;$i<10;$i++)
	{
		$classed_severity[$i]=0;
	}
	foreach($all_scores as $value)
	{
		if(isset($value))
		{
			if($value==10)
			{
				$classed_severity[9] ++ ;
			}
			else
			{
				$classed_severity[floor($value)] ++ ;
			}
		}
	}
	$H = $classed_severity ;
	$smarty->assign('H',$H);
	array_unshift($classed_severity, 'severity');
	
	$smarty->assign('include_id',$block['include_id']);
	$smarty->assign('var_chart_culumn_x',$severity_class);
	$smarty->assign('var_chart_culumn_y',$classed_severity);	
	//$smarty->assign('action', 'vsrv-nicolas-dev');
	
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
}
elseif($action=="update")
{
    //Code permettant l'administration du bloc
	$parameters = $block['parameters'];

	if($parameters['type']=="noeud")
	{
		$nodes = Model_esia::getNodeList($dbconnection, $user->getId(), NULL, Model_esia::NODE_ASSOC);
		$nodesList = array();
		foreach($nodes as $node)
		{
			$nodesList[] = array('id' => $node['id'], 'name' => $node['name']);
		}
		$smarty->assign('adm_list_node', $nodesList);
	}
	else
	{
		$list = Model_esia::getNodeGroupHierarchyByUser($dbconnection,$user->getId());
		$list_group_node=array();
		foreach($list as $node)
		{
			$selected='no';
			if(in_array($node['id'],$parameters['groupnodeid']))
			{
				$selected='yes';
			}
			
			$list_group_node[]=array('id'=>$node['id'],
				'name'=>$node['name'],
				'selected'=>$selected);
		}
		$smarty->assign('adm_list_group_node', $list_group_node);
	}
	
        $parameters = $block['parameters'];
	$smarty->assign('param',$parameters);	
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
                //on traite le formulaire
		try
		{ 
                       //traite les données post pour le style du titre et de la description
						$block = getPostDefaultParams($block,$_POST);
						$parameters = $block['parameters'];

						if($parameters['type']=='noeud')
						{
							$parameters['nodeid']=$_POST['nodes'];
						}
						else
						{
							$parameters['groupnodeid']=$_POST['groupnodes'];
						}
                      
                       //traitement des variable POST
			$paramSave = json_encode($parameters);
			Model_Report::UpdtReportIncludeBlock($dbconnection,$block['id'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);
                        //la variable l_success est affichée en rouge dans le smarty
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
                        //la variable l_error est affichée en rouge dans le smarty
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}   
       }
       //récupération des styles:
       	//recupération des styles
	$title = $parameters['title']['style'];
	$description = $parameters['description']['style'];
	$title = getBlockStyle($title,14,'left','#575759');
	$description = getBlockStyle($description,12,'left','#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
        //récupération des données pour l'affichage
        //on fixe le mode update
        $smarty->assign('action','update');
}


//chemin d'accès au template de votre block
$smarty->display($webplugin_path.'blocks/templates/egidescan_severity.html');
?>
