<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
require_once REPORT_COMMON_BLOCK;
require_once '/usr/local/esia/public_html/plugin/inventory/Model_inventory.php';

if($action=="generate")
{
    //code qui va générer l'HTML du bloc (attention en CRON au DOCUMENT_ROOT qui n'existe pas

    $parameters = $block['parameters'];

    if($parameters['rules_follow'] == "FOLLOW")
    {
        $rules_follow = "OK";
    }
    elseif($parameters['rules_follow'] == "NOT_FOLLOW")
    {
        $rules_follow = "OUTDATED";
    }
    else
    {
        $rules_follow = "ALL";
    }



    if($parameters['type']== "noeud")
    {
        $tab_id = $parameters['nodeid'];
        $rules = Model_inventory::getReportRules($dbconnection,"NODE",$rules_follow,$tab_id);
    }
    elseif($parameters['type'] == "group_node")
    {

        $tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$parameters['groupnodeid']);
        foreach ($tab_group_node as $node)
        {
            $tab_id_node[] = $node->getId();
        }

        $rules = Model_inventory::getReportRules($dbconnection,"GROUPNODE",$rules_follow,$tab_id_node);
    }
    else
    {
        $rules = Model_inventory::getReportRules($dbconnection,"ALL",$rules_follow,NULL);
    }
    $smarty->assign('rules',$rules);
}
elseif($action=="update")
{
    //Code permettant l'administration du bloc
    $parameters = $block['parameters'];
	$smarty->assign('param',$parameters);
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		try
		{
            //traite les données post pour le style du titre et de la description
            $block = getPostDefaultParams($block,$_POST);

            //traitement des variable POST
            if ($parameters['type']=='noeud')
			{
				$parameters['nodeid']=$_POST['nodes'];
			}
            if($parameters['type']=='group_node')
            {
                $parameters['groupnodeid']=$_POST['groupnodes'];
            }
			$parameters['rules_follow'] = $_POST['rules_follow'];
            $parameters['display_version'] = $_POST['version'];


			$paramSave = json_encode($parameters);
			Model_Report::UpdtReportIncludeBlock($dbconnection,$block['id'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);
            //la variable l_success est affichée en rouge dans le smarty
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
            //la variable l_error est affichée en rouge dans le smarty
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
    }

    assignCommonStyles($smarty,$parameters);

    if($parameters['type']=="noeud")
	{
		//Récupération des noeuds
		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		$list=array();
		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$parameters['nodeid']))
			{
				$selected='yes';
			}
			$list[]=array('id'=>$node->getId(),
					'name'=>$node->getGroup().'>'.$node->getName(),
					'selected'=>$selected

			);
		}
	}
    if($parameters['type'] =="group_node")
    {
        $groupNode = Model_esia::getGroupDeviceIn($dbconnection);
        $list_group_node =array();
        //echo var_dump($groupNode);
        foreach($groupNode as $group)
        {
            $select='no';
            if(in_array($group['id'],$parameters['groupnodeid']))
            {
                $select='yes';
            }
            $list_group_node[]=array('id'=>$group['id'],
                          'name'=>$group['name'],
                          'selected'=>$select
                          );
        }

    }

    $smarty->assign('adm_list_node', $list);
	$smarty->assign('adm_list_group_node', $list_group_node);

    //on fixe le mode update
    $smarty->assign('action','update');
}
//chemin d'accès au template de votre block
$smarty->display($webplugin_path.'blocks/templates/inventory_rules.html');
?>
